/**
 * @file
 * Token Field Description test (tokdesctst) Javascript behaviors.
 */

/*jslint browser: true, continue: true, indent: 2, newcap: true, nomen: true, plusplus: true, regexp: true, white: true, ass: true*/
/*global alert: false, confirm: false, console: false*/
/*global jQuery: false, Drupal: false*/

(function ($) {
  'use strict';

  Drupal.behaviors.tokdesctst = {
    attach: function (context) {
      var elms, le, i, type, s, n = 0, m, rgx = /\[current\-date:short\]/, em, ems = [], $display, nErrors = {
        description: 0
      };

      type = 'description';
      le = (elms = $('div.description,div.fieldset-description').get()).length;
      m = 0;
      for (i = 0; i < le; i++) {
        if ((s = elms[i].innerHTML).indexOf('[current-date:short]') > -1) {
          ems.push(s);
          console.log(type + '(' + (++m) + ')' + ': ' + s);
          $(elms[i]).html(s = s.replace(rgx, '<span class="tokdesctst">TOKEN</span>'));
          ++n;
          ++nErrors[type];
        }
      }

      if (!($display = $('div.tokdesctst-error-display')).length) {
        $display = $('<div class="tokdesctst-error-display" title="Click to close"></div>').appendTo('body');
        $display.click(function() {
          $(this).hide();
        });
      }

      if (n) {
        $display.html('<strong>Unreplaced token(s) found</strong><ol><li>' + ems.join('</li><li>') + '</li>').show();
      }
      else {
        console.log('Found no token replacement errors.');
        $display.html('Found no token replacement errors.').show();
      }
    }
  };
}(jQuery));
